"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ListReferenceBasesRequest(ProtocolElement):
    """
    The query parameters for a request to `GET /references/{id}/bases`,
    for example:  `GET /references/{id}/bases?start=100&end=200`
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import ga4gh as ga4gh_3_1_1

        return {
            "org.ga4gh.methods.ListReferenceBasesRequest": ga4gh_3_1_1.ListReferenceBasesRequest,
        }

    __slots__ = [
        "end",
        "pageToken",
        "start",
    ]

    def __init__(
        self,
        end=None,
        pageToken=None,
        start=0,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_1.ListReferenceBasesRequest model.

        :param end:
            The end position (0-based, exclusive) of this query. Defaults   to the
            length of this `Reference`.
        :type end: None | int
        :param pageToken:
            The continuation token, which is used to page through large result
            sets.   To get the next page of results, set this
            parameter to the value of   `nextPageToken` from the
            previous response.
        :type pageToken: None | str
        :param start:
            The start position (0-based) of this query. Defaults to 0.   Genomic
            positions are non-negative integers less than reference
            length.   Requests spanning the join of circular genomes
            are represented as   two requests one on each side of the
            join (position 0).
        :type start: int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.1"
